diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index ec3d8fba8..828a9b86e 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -18,18 +18,20 @@ import static net.minecraft.datagen.RecipesGenerator.CORE_NAMESPACE;
 
 class WorkbenchGenerator {
     public static void generate() {
-        generatePickaxes();
-        generateAxes();
-        generateShovels();
-        generateHoes();
-        generateSwords();
+
+        RecipeBuilder.consolidationGroup("pickaxes", WorkbenchGenerator::generatePickaxes);
+        RecipeBuilder.consolidationGroup("axes", WorkbenchGenerator::generateAxes);
+        RecipeBuilder.consolidationGroup("shovels", WorkbenchGenerator::generateShovels);
+        RecipeBuilder.consolidationGroup("hoes", WorkbenchGenerator::generateHoes);
+        RecipeBuilder.consolidationGroup("swords", WorkbenchGenerator::generateSwords);
+
         generateMiscTools();
 
-        generateHelmets();
-        generateChestPlates();
-        generateLeggings();
-        generateBoots();
-        generateWolfArmors();
+        RecipeBuilder.consolidationGroup("helmets", WorkbenchGenerator::generateHelmets);
+        RecipeBuilder.consolidationGroup("chestplates", WorkbenchGenerator::generateChestPlates);
+        RecipeBuilder.consolidationGroup("leggings", WorkbenchGenerator::generateLeggings);
+        RecipeBuilder.consolidationGroup("boots", WorkbenchGenerator::generateBoots);
+        RecipeBuilder.consolidationGroup("wolf_armors", WorkbenchGenerator::generateWolfArmors);
 
         generateBlockCompression();
         generateBlockDecompression();
@@ -61,8 +63,8 @@ class WorkbenchGenerator {
         generateUndyeingRecipes();
         generateDyeingRecipes();
 
-        generateStatueRecipes();
-        generateAcidConversions();
+        RecipeBuilder.consolidationGroup("statues", WorkbenchGenerator::generateStatueRecipes);
+        RecipeBuilder.consolidationGroup("acid_conversions", WorkbenchGenerator::generateAcidConversions);
 
         generateMiscNewRecipes();
 
@@ -92,18 +94,12 @@ class WorkbenchGenerator {
             .addInput('X', Items.WHEAT)
             .create("basket", Items.BASKET.getDefaultStack());
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#",
-                "#",
-                "#")
-            .addInput('#', Items.PAPER)
-            .create("book_vertical", Items.BOOK.getDefaultStack());
-
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape("###")
-            .addInput('#', Items.PAPER)
-            .create("book_horizontal", Items.BOOK.getDefaultStack());
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Items.PAPER)
+            .addInput(Items.PAPER)
+            .addInput(Items.PAPER)
+            .addInput(Items.LEATHER)
+            .create("book", Items.BOOK.getDefaultStack());
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -198,21 +194,23 @@ class WorkbenchGenerator {
             .addInput('W', "minecraft:wools")
             .create("painting", new ItemStack(Items.PAINTING, 1, Items.PAINTING.getMaxDamage()));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "XXX",
-                "X X",
-                "XXX")
-            .addInput('X', Items.INGOT_IRON)
-            .create("mesh", new ItemStack(Blocks.MESH, 8));
+        RecipeBuilder.consolidationGroup("mesh", () -> {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "XXX",
+                    "X X",
+                    "XXX")
+                .addInput('X', Items.INGOT_IRON)
+                .create("mesh", new ItemStack(Blocks.MESH, 8));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "XXX",
-                "X X",
-                "XXX")
-            .addInput('X', Items.INGOT_GOLD)
-            .create("mesh_gold", new ItemStack(Blocks.MESH_GOLD, 8));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "XXX",
+                    "X X",
+                    "XXX")
+                .addInput('X', Items.INGOT_GOLD)
+                .create("mesh_gold", new ItemStack(Blocks.MESH_GOLD, 8));
+        });
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -258,40 +256,57 @@ class WorkbenchGenerator {
         shape22.addInput('#', Items.AMMO_SNOWBALL).create("snow_block", Blocks.BLOCK_SNOW.getDefaultStack());
         shape22.addInput('#', Items.STRING).create("string_to_wool", Blocks.WOOL.getDefaultStack());
         shape22.addInput('#', Items.AMMO_PEBBLE).create("pebbles_to_cobblestone", new ItemStack(Blocks.COBBLE_STONE, 2));
-        shape22.addInput('#', Blocks.SAND).create("sandstone", new ItemStack(Blocks.SANDSTONE, 2));
+
+        RecipeBuilder.consolidationGroup("sand_to_stone", () ->
+            shape22.addInput('#', Blocks.SAND).create("sandstone", new ItemStack(Blocks.SANDSTONE, 2))
+        );
+        RecipeBuilder.consolidationGroup("sand_to_stone", () ->
+            shape22.addInput('#', Blocks.BRIMSAND).create("brimstone", new ItemStack(Blocks.BRIMSTONE,2))
+        );
+
         shape22.addInput('#', "minecraft:planks").create("workbench", Blocks.WORKBENCH.getDefaultStack());
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#X",
-                "X#")
-            .addInput('#', Items.AMMO_PEBBLE)
-            .addInput('X', Items.COAL)
-            .create("pebbles_to_basalt", new ItemStack(Blocks.COBBLE_BASALT, 2));
+        RecipeBuilder.consolidationGroup("cobble_variants", () -> {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Items.AMMO_PEBBLE)
+                .addInput('X', Items.COAL)
+                .create("pebbles_to_basalt", new ItemStack(Blocks.COBBLE_BASALT, 2));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#X",
-                "X#")
-            .addInput('#', Items.AMMO_PEBBLE)
-            .addInput('X', Items.QUARTZ)
-            .create("pebbles_to_granite", new ItemStack(Blocks.COBBLE_GRANITE, 2));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Items.AMMO_PEBBLE)
+                .addInput('X', Items.QUARTZ)
+                .create("pebbles_to_granite", new ItemStack(Blocks.COBBLE_GRANITE, 2));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#X",
-                "X#")
-            .addInput('#', Items.AMMO_PEBBLE)
-            .addInput('X', Blocks.SAND)
-            .create("pebbles_to_limestone", new ItemStack(Blocks.COBBLE_LIMESTONE, 2));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Items.AMMO_PEBBLE)
+                .addInput('X', Blocks.SAND)
+                .create("pebbles_to_limestone", new ItemStack(Blocks.COBBLE_LIMESTONE, 2));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#X",
-                "X#")
-            .addInput('#', Items.AMMO_PEBBLE)
-            .addInput('X', Blocks.ICE)
-            .create("pebbles_to_permafrost", new ItemStack(Blocks.COBBLE_PERMAFROST, 2));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Items.AMMO_PEBBLE)
+                .addInput('X', Blocks.ICE)
+                .create("pebbles_to_permafrost", new ItemStack(Blocks.COBBLE_PERMAFROST, 2));
+
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Items.AMMO_PEBBLE)
+                .addInput('X', Blocks.OBSIDIAN)
+                .create("pebbles_to_gloomstone", new ItemStack(Blocks.COBBLE_GLOOMSTONE, 2));
+        });
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -316,21 +331,23 @@ class WorkbenchGenerator {
             .addInput('#', Items.STRING)
             .create("rope", new ItemStack(Items.ROPE, 2));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#X",
-                "X#")
-            .addInput('#', Blocks.GLASS)
-            .addInput('X', Items.INGOT_STEEL_CRUDE)
-            .create("steel_glass", new ItemStack(Blocks.GLASS_STEEL, 4));
+        RecipeBuilder.consolidationGroup("treated_glass", () -> {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Blocks.GLASS)
+                .addInput('X', Items.INGOT_STEEL_CRUDE)
+                .create("steel_glass", new ItemStack(Blocks.GLASS_STEEL, 4));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "#X",
-                "X#")
-            .addInput('#', Blocks.GLASS)
-            .addInput('X', Items.OLIVINE)
-            .create("tinted_glass", new ItemStack(Blocks.GLASS_TINTED, 4));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#X",
+                    "X#")
+                .addInput('#', Blocks.GLASS)
+                .addInput('X', Items.OLIVINE)
+                .create("tinted_glass", new ItemStack(Blocks.GLASS_TINTED, 4));
+        });
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -340,37 +357,50 @@ class WorkbenchGenerator {
             .addInput('X', "minecraft:planks")
             .create("paper_wall", new ItemStack(Blocks.PAPER_WALL, 4));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "X",
-                "#")
-            .addInput('#', Items.STICK)
-            .addInput('X', Items.COAL)
-            .create("torch_coal", new ItemStack(Blocks.TORCH_COAL, 4));
+        RecipeBuilder.consolidationGroup("torches", () -> {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "X",
+                    "#")
+                .addInput('#', Items.STICK)
+                .addInput('X', Items.COAL)
+                .create("torch_coal", new ItemStack(Blocks.TORCH_COAL, 4));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "X",
-                "#")
-            .addInput('#', Items.STICK)
-            .addInput('X', Items.COAL, 1)
-            .create("torch_charcoal", new ItemStack(Blocks.TORCH_COAL, 4));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "X",
+                    "#")
+                .addInput('#', Items.STICK)
+                .addInput('X', Items.COAL, 1)
+                .create("torch_charcoal", new ItemStack(Blocks.TORCH_COAL, 4));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "X",
-                "#")
-            .addInput('#', Items.STICK)
-            .addInput('X', Items.NETHERCOAL)
-            .create("torch_nethercoal", new ItemStack(Blocks.TORCH_COAL, 8));
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "X",
+                    "#")
+                .addInput('#', Items.STICK)
+                .addInput('X', Items.NETHERCOAL)
+                .create("torch_nethercoal", new ItemStack(Blocks.TORCH_COAL, 8));
+        });
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "X",
-                "#")
-            .addInput('X', Blocks.PUMPKIN_CARVED_IDLE)
-            .addInput('#', Blocks.TORCH_COAL)
-            .create("carved_pumpkin_to_jack_o_lantern", Blocks.PUMPKIN_CARVED_ACTIVE.getDefaultStack());
+
+        RecipeBuilder.consolidationGroup("jack_o_lanterns", () -> {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                    .setShape(
+                            "X",
+                            "#")
+                    .addInput('X', Blocks.PUMPKIN_CARVED_IDLE)
+                    .addInput('#', Blocks.TORCH_COAL)
+                    .create("carved_pumpkin_to_jack_o_lantern", Blocks.PUMPKIN_CARVED_ACTIVE.getDefaultStack());
+
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                    .setShape(
+                            "X",
+                            "#")
+                    .addInput('X', Blocks.PUMPKIN_CARVED_IDLE)
+                    .addInput('#', Blocks.TORCH_REDSTONE_ACTIVE)
+                    .create("carved_pumpkin_to_redstone_jack_o_lantern", Blocks.PUMPKIN_REDSTONE.getDefaultStack());
+        });
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(Blocks.SPONGE_DRY)
@@ -386,23 +416,23 @@ class WorkbenchGenerator {
             .addInput(Blocks.PUMPKIN)
             .create("pumpkin_to_pumpkin_seeds", new ItemStack(Items.SEEDS_PUMPKIN, 4));
 
-        RecipeBuilder.Shapeless(CORE_NAMESPACE)
-            .addInput(Blocks.SLATE)
-            .create("slate_to_slate_layers", new ItemStack(Blocks.LAYER_SLATE, 8));
+        RecipeBuilder.consolidationGroup("layers", () -> {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Blocks.SLATE)
+                .create("slate_to_slate_layers", new ItemStack(Blocks.LAYER_SLATE, 8));
 
-        RecipeBuilder.Shapeless(CORE_NAMESPACE)
-            .addInput(Blocks.BLOCK_ASH)
-            .create("ash_to_ash_layers", new ItemStack(Blocks.LAYER_ASH, 8));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Blocks.BLOCK_ASH)
+                .create("ash_to_ash_layers", new ItemStack(Blocks.LAYER_ASH, 8));
 
-        RecipeBuilder.Shapeless(CORE_NAMESPACE)
-            .addInput(Blocks.LEAVES_OAK)
-            .create("oak_leaves_to_leaf_pile", new ItemStack(Blocks.LAYER_LEAVES_OAK, 8));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Blocks.LEAVES_OAK)
+                .create("oak_leaves_to_leaf_pile", new ItemStack(Blocks.LAYER_LEAVES_OAK, 8));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "##")
-            .addInput('#', Items.AMMO_SNOWBALL)
-            .create("snowballs_to_snow_layer", new ItemStack(Blocks.LAYER_SNOW, 2));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Blocks.BLOCK_SNOW)
+                .create("snow_block_to_snow_layers", new ItemStack(Blocks.LAYER_SNOW, 8));
+        });
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -452,23 +482,25 @@ class WorkbenchGenerator {
             .addInput('S', Items.SULFUR)
             .create("ember", Blocks.EMBER.getDefaultStack());
 
-        RecipeBuilder.Shapeless(CORE_NAMESPACE)
-            .addInput(Items.SULFUR)
-            .addInput(Items.COAL)
-            .addInput(Items.PAPER)
-            .create("gunpowder_with_coal", new ItemStack(Items.GUNPOWDER, 2));
-
-        RecipeBuilder.Shapeless(CORE_NAMESPACE)
-            .addInput(Items.SULFUR)
-            .addInput(new ItemStack(Items.COAL, 1, 1))
-            .addInput(Items.PAPER)
-            .create("gunpowder_with_charcoal", new ItemStack(Items.GUNPOWDER, 2));
-
-        RecipeBuilder.Shapeless(CORE_NAMESPACE)
-            .addInput(Items.SULFUR)
-            .addInput(Items.NETHERCOAL)
-            .addInput(Items.PAPER)
-            .create("gunpowder_with_nethercoal", new ItemStack(Items.GUNPOWDER, 4));
+        RecipeBuilder.consolidationGroup("gunpowder", () -> {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Items.SULFUR)
+                .addInput(Items.COAL)
+                .addInput(Items.PAPER)
+                .create("gunpowder_with_coal", new ItemStack(Items.GUNPOWDER, 2));
+
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Items.SULFUR)
+                .addInput(new ItemStack(Items.COAL, 1, 1))
+                .addInput(Items.PAPER)
+                .create("gunpowder_with_charcoal", new ItemStack(Items.GUNPOWDER, 2));
+
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Items.SULFUR)
+                .addInput(Items.NETHERCOAL)
+                .addInput(Items.PAPER)
+                .create("gunpowder_with_nethercoal", new ItemStack(Items.GUNPOWDER, 4));
+        });
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(Blocks.RUBYGLASS_COLUMN)
@@ -576,11 +608,15 @@ class WorkbenchGenerator {
                 " X",
                 "X ");
 
-        shears.addInput('X', Items.INGOT_IRON).create("shears", Items.TOOL_SHEARS.getDefaultStack());
-        shears.addInput('X', Items.INGOT_STEEL).create("steel_shears", Items.TOOL_SHEARS_STEEL.getDefaultStack());
+        RecipeBuilder.consolidationGroup("shears", () -> {
+            shears.addInput('X', Items.INGOT_IRON).create("shears", Items.TOOL_SHEARS.getDefaultStack());
+            shears.addInput('X', Items.INGOT_STEEL).create("steel_shears", Items.TOOL_SHEARS_STEEL.getDefaultStack());
+        });
 
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.INGOT_IRON).addInput(Items.FLINT).create("fire_striker", Items.TOOL_FIRESTRIKER_IRON.getDefaultStack());
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.INGOT_STEEL).addInput(Items.FLINT).create("steel_fire_striker", Items.TOOL_FIRESTRIKER_STEEL.getDefaultStack());
+        RecipeBuilder.consolidationGroup("fire_strikers", () -> {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.INGOT_IRON).addInput(Items.FLINT).create("fire_striker", Items.TOOL_FIRESTRIKER_IRON.getDefaultStack());
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.INGOT_STEEL).addInput(Items.FLINT).create("steel_fire_striker", Items.TOOL_FIRESTRIKER_STEEL.getDefaultStack());
+        });
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -784,37 +820,43 @@ class WorkbenchGenerator {
                 "XXX"
             );
 
-        block.addInput('X', Items.INGOT_GOLD).create("block_of_gold", Blocks.BLOCK_GOLD.getDefaultStack());
-        block.addInput('X', Items.INGOT_IRON).create("block_of_iron", Blocks.BLOCK_IRON.getDefaultStack());
-        block.addInput('X', Items.INGOT_STEEL).create("block_of_steel", Blocks.BLOCK_STEEL.getDefaultStack());
-        block.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("block_of_lapis_lazuli", Blocks.BLOCK_LAPIS.getDefaultStack());
-        block.addInput('X', Items.DUST_REDSTONE).create("block_of_redstone", Blocks.BLOCK_REDSTONE.getDefaultStack());
-        block.addInput('X', Items.DIAMOND).create("block_of_diamond", Blocks.BLOCK_DIAMOND.getDefaultStack());
-        block.addInput('X', Items.QUARTZ).create("block_of_quartz", Blocks.BLOCK_QUARTZ.getDefaultStack());
-        block.addInput('X', Items.SUGARCANE).create("block_of_sugarcane", Blocks.BLOCK_SUGARCANE.getDefaultStack());
-        block.addInput('X', Items.RUBYGLASS).create("block_of_rubyglass", Blocks.BLOCK_RUBYGLASS.getDefaultStack());
-
-        blockFuel.addInput('X', Items.COAL, 0).create("block_of_coal", Blocks.BLOCK_COAL.getDefaultStack());
-        blockFuel.addInput('X', Items.COAL, 1).create("block_of_charcoal", Blocks.BLOCK_CHARCOAL.getDefaultStack());
-        blockFuel.addInput('X', Items.NETHERCOAL).create("block_of_nethercoal", Blocks.BLOCK_NETHER_COAL.getDefaultStack());
-        blockFuel.addInput('X', Items.OLIVINE).create("block_of_olivine", Blocks.BLOCK_OLIVINE.getDefaultStack());
+        RecipeBuilder.consolidationGroup("material_blocks", () -> {
+            block.addInput('X', Items.INGOT_GOLD).create("block_of_gold", Blocks.BLOCK_GOLD.getDefaultStack());
+            block.addInput('X', Items.INGOT_IRON).create("block_of_iron", Blocks.BLOCK_IRON.getDefaultStack());
+            block.addInput('X', Items.INGOT_STEEL).create("block_of_steel", Blocks.BLOCK_STEEL.getDefaultStack());
+            block.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("block_of_lapis_lazuli", Blocks.BLOCK_LAPIS.getDefaultStack());
+            block.addInput('X', Items.DUST_REDSTONE).create("block_of_redstone", Blocks.BLOCK_REDSTONE.getDefaultStack());
+            block.addInput('X', Items.DIAMOND).create("block_of_diamond", Blocks.BLOCK_DIAMOND.getDefaultStack());
+            block.addInput('X', Items.QUARTZ).create("block_of_quartz", Blocks.BLOCK_QUARTZ.getDefaultStack());
+            block.addInput('X', Items.SUGARCANE).create("block_of_sugarcane", Blocks.BLOCK_SUGARCANE.getDefaultStack());
+            block.addInput('X', Items.RUBYGLASS).create("block_of_rubyglass", Blocks.BLOCK_RUBYGLASS.getDefaultStack());
+        });
+
+        RecipeBuilder.consolidationGroup("burnable_material_blocks", () -> {
+            blockFuel.addInput('X', Items.COAL, 0).create("block_of_coal", Blocks.BLOCK_COAL.getDefaultStack());
+            blockFuel.addInput('X', Items.COAL, 1).create("block_of_charcoal", Blocks.BLOCK_CHARCOAL.getDefaultStack());
+            blockFuel.addInput('X', Items.NETHERCOAL).create("block_of_nethercoal", Blocks.BLOCK_NETHER_COAL.getDefaultStack());
+            blockFuel.addInput('X', Items.OLIVINE).create("block_of_olivine", Blocks.BLOCK_OLIVINE.getDefaultStack());
+        });
     }
 
     private static void generateBlockDecompression() {
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_GOLD).create("block_of_gold_to_gold_ingot", new ItemStack(Items.INGOT_GOLD, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_IRON).create("block_of_iron_to_iron_ingot", new ItemStack(Items.INGOT_IRON, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_STEEL).create("block_of_steel_to_steel_ingot", new ItemStack(Items.INGOT_STEEL, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_LAPIS).create("block_of_lapis_lazuli_to_lapis_lazuli", new ItemStack(Items.DYE, 9, DyeColor.BLUE.itemMeta));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_REDSTONE).create("block_of_redstone_to_redstone", new ItemStack(Items.DUST_REDSTONE, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_DIAMOND).create("block_of_diamond_to_diamond", new ItemStack(Items.DIAMOND, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_QUARTZ).create("block_of_quartz_to_quartz", new ItemStack(Items.QUARTZ, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_RUBYGLASS).create("block_of_rubyglass_to_rubyglass", new ItemStack(Items.RUBYGLASS, 9));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_SUGARCANE).create("block_of_sugarcane_to_sugarcane", new ItemStack(Items.SUGARCANE, 9));
-
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_COAL).create("block_of_coal_to_coal", new ItemStack(Items.COAL, 8, 0));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_CHARCOAL).create("block_of_charcoal_to_charcoal", new ItemStack(Items.COAL, 8, 1));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_NETHER_COAL).create("block_of_nethercoal_to_nethercoal", new ItemStack(Items.NETHERCOAL, 8));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_OLIVINE).create("block_of_olivine_to_olivine", new ItemStack(Items.OLIVINE, 8));
+        RecipeBuilder.consolidationGroup("material_block_breakdown", () -> {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_GOLD).create("block_of_gold_to_gold_ingot", new ItemStack(Items.INGOT_GOLD, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_IRON).create("block_of_iron_to_iron_ingot", new ItemStack(Items.INGOT_IRON, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_STEEL).create("block_of_steel_to_steel_ingot", new ItemStack(Items.INGOT_STEEL, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_LAPIS).create("block_of_lapis_lazuli_to_lapis_lazuli", new ItemStack(Items.DYE, 9, DyeColor.BLUE.itemMeta));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_REDSTONE).create("block_of_redstone_to_redstone", new ItemStack(Items.DUST_REDSTONE, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_DIAMOND).create("block_of_diamond_to_diamond", new ItemStack(Items.DIAMOND, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_QUARTZ).create("block_of_quartz_to_quartz", new ItemStack(Items.QUARTZ, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_RUBYGLASS).create("block_of_rubyglass_to_rubyglass", new ItemStack(Items.RUBYGLASS, 9));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_SUGARCANE).create("block_of_sugarcane_to_sugarcane", new ItemStack(Items.SUGARCANE, 9));
+
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_COAL).create("block_of_coal_to_coal", new ItemStack(Items.COAL, 8, 0));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_CHARCOAL).create("block_of_charcoal_to_charcoal", new ItemStack(Items.COAL, 8, 1));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_NETHER_COAL).create("block_of_nethercoal_to_nethercoal", new ItemStack(Items.NETHERCOAL, 8));
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_OLIVINE).create("block_of_olivine_to_olivine", new ItemStack(Items.OLIVINE, 8));
+        });
     }
 
     private static void generateBricks() {
@@ -825,26 +867,31 @@ class WorkbenchGenerator {
             );
 
         final int stackSize = 4;
-        bricks.addInput('X', Items.RUBYGLASS).create("rubyglass_bricks", new ItemStack(Blocks.BRICK_RUBYGLASS, stackSize));
-        bricks.addInput('X', Items.DIAMOND).create("diamond_bricks", new ItemStack(Blocks.BRICK_DIAMOND, stackSize));
-        bricks.addInput('X', Items.BRICK_CLAY).create("clay_bricks", new ItemStack(Blocks.BRICK_CLAY, stackSize));
-        bricks.addInput('X', Items.INGOT_GOLD).create("golden_bricks", new ItemStack(Blocks.BRICK_GOLD, stackSize));
-        bricks.addInput('X', Items.INGOT_IRON).create("iron_bricks", new ItemStack(Blocks.BRICK_IRON, stackSize));
-        bricks.addInput('X', Items.INGOT_STEEL_CRUDE).create("steel_bricks", new ItemStack(Blocks.BRICK_STEEL, stackSize));
-        bricks.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("lapis_lazuli_bricks", new ItemStack(Blocks.BRICK_LAPIS, stackSize));
-        bricks.addInput('X', Items.OLIVINE).create("olivine_bricks", new ItemStack(Blocks.BRICK_OLIVINE, stackSize));
-        bricks.addInput('X', Items.QUARTZ).create("quartz_bricks", new ItemStack(Blocks.BRICK_QUARTZ, stackSize));
-        bricks.addInput('X', Blocks.SANDSTONE).create("sandstone_bricks", new ItemStack(Blocks.BRICK_SANDSTONE, stackSize));
-        bricks.addInput('X', Blocks.STONE).create("stone_bricks", new ItemStack(Blocks.BRICK_STONE, stackSize));
-        bricks.addInput('X', Blocks.BASALT).create("basalt_bricks", new ItemStack(Blocks.BRICK_BASALT, stackSize));
-        bricks.addInput('X', Blocks.GRANITE).create("granite_bricks", new ItemStack(Blocks.BRICK_GRANITE, stackSize));
-        bricks.addInput('X', Blocks.LIMESTONE).create("limestone_bricks", new ItemStack(Blocks.BRICK_LIMESTONE, stackSize));
-        bricks.addInput('X', Blocks.MARBLE).create("marble_bricks", new ItemStack(Blocks.BRICK_MARBLE, stackSize));
-        bricks.addInput('X', Blocks.SLATE).create("slate_bricks", new ItemStack(Blocks.BRICK_SLATE, stackSize));
-        bricks.addInput('X', Blocks.PERMAFROST).create("permafrost_bricks", new ItemStack(Blocks.BRICK_PERMAFROST, stackSize));
-        bricks.addInput('X', Blocks.NETHERRACK).create("netherrack_bricks", new ItemStack(Blocks.BRICK_NETHERRACK, stackSize));
-        bricks.addInput('X', Blocks.GLOOMSTONE).create("gloomstone_bricks", new ItemStack(Blocks.BRICK_GLOOMSTONE, stackSize));
-        bricks.addInput('X', Blocks.STONE_POLISHED).create("polished_stone_bricks", new ItemStack(Blocks.BRICK_STONE_POLISHED, stackSize));
+        RecipeBuilder.consolidationGroup("material_type_bricks", () -> {
+            bricks.addInput('X', Items.RUBYGLASS).create("rubyglass_bricks", new ItemStack(Blocks.BRICK_RUBYGLASS, stackSize));
+            bricks.addInput('X', Items.DIAMOND).create("diamond_bricks", new ItemStack(Blocks.BRICK_DIAMOND, stackSize));
+            bricks.addInput('X', Items.BRICK_CLAY).create("clay_bricks", new ItemStack(Blocks.BRICK_CLAY, stackSize));
+            bricks.addInput('X', Items.INGOT_GOLD).create("golden_bricks", new ItemStack(Blocks.BRICK_GOLD, stackSize));
+            bricks.addInput('X', Items.INGOT_IRON).create("iron_bricks", new ItemStack(Blocks.BRICK_IRON, stackSize));
+            bricks.addInput('X', Items.INGOT_STEEL_CRUDE).create("steel_bricks", new ItemStack(Blocks.BRICK_STEEL, stackSize));
+            bricks.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("lapis_lazuli_bricks", new ItemStack(Blocks.BRICK_LAPIS, stackSize));
+            bricks.addInput('X', Items.OLIVINE).create("olivine_bricks", new ItemStack(Blocks.BRICK_OLIVINE, stackSize));
+            bricks.addInput('X', Items.QUARTZ).create("quartz_bricks", new ItemStack(Blocks.BRICK_QUARTZ, stackSize));
+        });
+        RecipeBuilder.consolidationGroup("stone_type_bricks", () -> {
+            bricks.addInput('X', Blocks.SANDSTONE).create("sandstone_bricks", new ItemStack(Blocks.BRICK_SANDSTONE, stackSize));
+            bricks.addInput('X', Blocks.STONE).create("stone_bricks", new ItemStack(Blocks.BRICK_STONE, stackSize));
+            bricks.addInput('X', Blocks.BASALT).create("basalt_bricks", new ItemStack(Blocks.BRICK_BASALT, stackSize));
+            bricks.addInput('X', Blocks.GRANITE).create("granite_bricks", new ItemStack(Blocks.BRICK_GRANITE, stackSize));
+            bricks.addInput('X', Blocks.LIMESTONE).create("limestone_bricks", new ItemStack(Blocks.BRICK_LIMESTONE, stackSize));
+            bricks.addInput('X', Blocks.MARBLE).create("marble_bricks", new ItemStack(Blocks.BRICK_MARBLE, stackSize));
+            bricks.addInput('X', Blocks.SLATE).create("slate_bricks", new ItemStack(Blocks.BRICK_SLATE, stackSize));
+            bricks.addInput('X', Blocks.PERMAFROST).create("permafrost_bricks", new ItemStack(Blocks.BRICK_PERMAFROST, stackSize));
+            bricks.addInput('X', Blocks.NETHERRACK).create("netherrack_bricks", new ItemStack(Blocks.BRICK_NETHERRACK, stackSize));
+            bricks.addInput('X', Blocks.GLOOMSTONE).create("gloomstone_bricks", new ItemStack(Blocks.BRICK_GLOOMSTONE, stackSize));
+            bricks.addInput('X', Blocks.BRIMSTONE).create("brimstone_bricks", new ItemStack(Blocks.BRICK_BRIMSTONE, stackSize));
+            bricks.addInput('X', Blocks.STONE_POLISHED).create("polished_stone_bricks", new ItemStack(Blocks.BRICK_STONE_POLISHED, stackSize));
+        });
     }
 
     private static void generateSlabs() {
